---------PvPGrid by Unrealrules-Eredar ----------


PvPGrid = LibStub("AceAddon-3.0"):NewAddon("PvPGrid", "AceEvent-3.0","AceConsole-3.0","AceTimer-3.0")

local testmode = false
-- "WenQuanYi Zen Hei" supports all regions but over 10 Megabyte LOL
-- local LSM = LibStub("LibSharedMedia-3.0")
-- local koKR, ruRU, zhCN, zhTW, western = LSM.LOCALE_BIT_koKR, LSM.LOCALE_BIT_ruRU, LSM.LOCALE_BIT_zhCN, LSM.LOCALE_BIT_zhTW, LSM.LOCALE_BIT_western
-- local MediaType_FONT = LSM.MediaType.FONT
-- LSM:Register(
	-- MediaType_FONT, "WenQuanYi Zen Hei",
	-- [[Interface\Addons\PvPGrid\fonts\wen_quan_yi_zen_hei\wqy-zenhei.ttf]],	
	-- koKR + ruRU + zhCN + zhTW + western)
	
local media = LibStub("LibSharedMedia-3.0")
media:Register("statusbar", "BantoBar",       [[Interface\Addons\Skada\media\statusbar\BantoBar]])
		



local dbDefaults = {
	profile = {	
		lock = false,
		frameheight = 20,
		framewidth = 225,
		fontsize = 17,
		mainfont = "Arial Narrow",
		statusbarframe = "BantoBar",
	}
}

function PvPGrid:OnInitialize()
	PvPGrid.db = LibStub("AceDB-3.0"):New("PvPGridDB", dbDefaults)
	self:getClassInfos()
	self:createdisplay()
	
	self:SetupOptions()
end

function PvPGrid:getClassInfos()
	self.Classinfos = {}
	for i = 1, MAX_CLASSES do
		local _, classnumber = GetClassInfoByID(i)
		local specnumbers = GetNumSpecializationsForClassID(i)

		self.Classinfos[classnumber] = {}
		for j = 1, specnumbers do
			local _,name,_,icon,role = GetSpecializationInfoForClassID(i, j)
			self.Classinfos[classnumber][j] = {specname = name, specicon = icon, specrole = role}
		end
	end
end

function PvPGrid:createplayer()
	self.player = {}
	self.player.faction = ''
	self.player.name = UnitName('player')
end

function PvPGrid:update_player()
	local playernumbers = GetNumBattlefieldScores()
	for i = 1, playernumbers do
		local name,_,_,_,_,faction,_,_,class,_ ,_,_,_,_,_,spec = GetBattlefieldScore(i)
		if PvPGrid.player then
			if name == PvPGrid.player.name then
				PvPGrid.player.faction = faction 
			end
		else
			self:createplayer()
		end
	end
end

function PvPGrid:OnEnable()
	self:createplayer()
	self.playergrid = {}
	
	
	self.playerinfos = {}
	self.mainframe:RegisterEvent('ZONE_CHANGED_NEW_AREA')
	self.mainframe:RegisterEvent('UPDATE_BATTLEFIELD_SCORE')
	self.mainframe:RegisterEvent('UNIT_TARGET')
	self.mainframe:RegisterEvent('UNIT_HEALTH_FREQUENT')
	self.mainframe:RegisterEvent('NAME_PLATE_UNIT_ADDED')
	self.mainframe:RegisterEvent('NAME_PLATE_UNIT_REMOVED')
	
	-- self.mainframe:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
	
	self.mainframe:SetScript('OnEvent', PvPGrid_OnEvent)
	self:PvP_Zone_check()
	self:OnOptionCreate()
end

function PvPGrid:createdisplay()
	
	self:create_mainframe()
	self:create_playerframes()
	self:create_flags_and_orbs()
	self:showgrid()
	if not testmode then
		self.mainframe:Hide()
	end
end

function PvPGrid:create_flags_and_orbs()
	local height = self.db.profile.frameheight 
	local fontsize = self.db.profile.fontsize 
	
	local frame = 'allianceflag'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\WorldStateFrame\AllianceFlag]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'hordeflag'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\WorldStateFrame\HordeFlag]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'netherflag'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\WorldStateFrame\ColumnIcon-FlagCapture2]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	
	frame = 'blueorb'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\inv_misc_enchantedpearlF]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'purpleorb'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\inv_misc_enchantedpearlD]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'orangeorb'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\inv_misc_enchantedpearlC]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	frame = 'greenorb'
	self.mainframe[frame] = self.mainframe:CreateTexture(nil, "OVERLAY")
	self.mainframe[frame]:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame]:SetSize(height , height)
	self.mainframe[frame]:SetTexture([[Interface\ICONS\inv_misc_enchantedpearlA]])
	self.mainframe[frame].fontname = self.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	self.mainframe[frame].fontname:SetPoint("TOPLEFT", 0, 0)
	self.mainframe[frame].fontname:SetText('x0.1')
	self.mainframe[frame].fontname:SetTextColor(1, 1, 1)
	self.mainframe[frame].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
	self.mainframe[frame]:Hide()
	
		
end

function PvPGrid:setflag(frame_id, number)
	local height = self.db.profile.frameheight 
	self.mainframe[frame_id]:Show()
	self.mainframe[frame_id]:SetPoint("TOPLEFT", -height*3-3, -(number-1)*height-10)
	self.mainframe[frame_id].fontname:SetPoint("TOPLEFT", -height*4-3-10, -(number-1)*height-10-height/4)
	self.mainframe[frame_id].fontname:Show()
end

function PvPGrid:HideFlag(frame_id)
	self.mainframe[frame_id]:Hide()
	self.mainframe[frame_id].fontname:Hide()
end

function PvPGrid:create_mainframe()
	PvPGrid.mainframe = CreateFrame("Frame", 'MainFrame', UIParent)
	PvPGrid.mainframe:SetPoint("Center", 0, 300)
	PvPGrid.mainframe:SetSize(150, 10)
	PvPGrid.mainframe:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
	PvPGrid.mainframe:SetBackdropColor(0.5, 0.5, 0.5, 0.3)
	PvPGrid.mainframe:SetMovable(true)
	if PvPGrid.db.profile.lock then
		PvPGrid.mainframe:EnableMouse(false)
	else
		PvPGrid.mainframe:EnableMouse(true)
	end	
	PvPGrid.mainframe:RegisterForDrag("LeftButton")
	PvPGrid.mainframe:SetScript("OnDragStart", PvPGrid.mainframe.StartMoving)
	PvPGrid.mainframe:SetScript("OnDragStop", PvPGrid.mainframe.StopMovingOrSizing)
	PvPGrid.mainframe:SetUserPlaced(true)
	
	PvPGrid.mainframe:SetScript("OnUpdate", function(self, frame) 
		local showflag_alliance = false
		local showflag_horde = false
		local showflag_nether = false
		
		local showorb_blue = false
		local showorb_purple = false
		local showorb_orange = false
		local showorb_green = false
		
		if testmode then
			showorb_blue = true
			showorb_purple = true
			showorb_orange = true
			showorb_green = true
		end
		for j= 1 , 4 , 1 do
			for i = 1, 40 ,1 do
				local currentMapId = GetCurrentMapAreaID()
				local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, canStealOrPurge, nameplateShowPersonal, spellId = UnitAura('arena'..j, i)
				
					if spellId == 156618 or spellId == 141210 then -- hordeflag
						local targetname, targetserver = UnitFullName('arena'..j)
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							PvPGrid:setflag('hordeflag', playernumber)
							showflag_horde = true
							for k = 1 , 15 , 1 do
								local spellId2 = select(11, UnitDebuff('arena'..j, k))
								local count = select(4, UnitDebuff('arena'..j, k))
								if spellId2 == 46392 or spellId2 == 46393 then
									local text = 'x'.. 1+count/10
									PvPGrid.mainframe['hordeflag'].fontname:SetText(text)
									break
								else
									local text = 'x'.. 1 .. '.0'
									PvPGrid.mainframe['hordeflag'].fontname:SetText(text)
								end
							end
						end
					end
					if spellId == 156621 or spellId == 140876 then -- allianceflag
						local targetname, targetserver = UnitFullName('arena'..j)
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							PvPGrid:setflag('allianceflag', playernumber)
							showflag_alliance = true
							for k = 1 , 15 , 1 do
								local spellId2 = select(11, UnitDebuff('arena'..j, k))
								local count = select(4, UnitDebuff('arena'..j, k))
								if spellId2 == 46392 or spellId2 == 46393 then
									local text = 'x'.. 1+count/10
									PvPGrid.mainframe['allianceflag'].fontname:SetText(text)
									break
								else
									local text = 'x'.. 1 .. '.0'
									PvPGrid.mainframe['hordeflag'].fontname:SetText(text)
								end
							end
						end
					end
				if spellId == 34976 then -- netherflag
					local targetname, targetserver = UnitFullName('arena'..j)
					if targetserver == nil then
					
					else
						targetname = targetname..'-'..targetserver 
					end
					local playernumber = PvPGrid:getPlayernumber(targetname)
					if playernumber ~= 0 then
						PvPGrid:setflag('netherflag', playernumber)
						showflag_nether = true
					end
				end
				
				if currentMapId == 856 then	
					local spellId2 = select(11, UnitDebuff('arena'..j, i))
					local val2 = select(18, UnitDebuff('arena'..j, i))
					--if spellId ~= nil then
						--print(spellId)
					--end
					if spellId2 == 121164 then -- blueorb 1
						local targetname, targetserver = UnitFullName('arena1')
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							local text = 'x'.. 1+val2/100
							PvPGrid.mainframe['blueorb'].fontname:SetText(text)
							PvPGrid:setflag('blueorb', playernumber)
							
							showorb_blue = true
						end
					end
					if spellId2 == 121175 then -- purpleorb 2
						local targetname, targetserver = UnitFullName('arena2')
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							local text = 'x'.. 1+val2/100
							PvPGrid.mainframe['purpleorb'].fontname:SetText(text)
							PvPGrid:setflag('purpleorb', playernumber)
							
							showorb_purple = true
						end
					end
					if spellId2 == 121177 then -- orangeorb 4
						local targetname, targetserver = UnitFullName('arena4')
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							local text = 'x'.. 1+val2/100
							PvPGrid.mainframe['orangeorb'].fontname:SetText(text)
							PvPGrid:setflag('orangeorb', playernumber)
							
							showorb_orange = true
						end
					end
					if spellId2 == 121176 then -- greenorb 3
						local targetname, targetserver = UnitFullName('arena3')
						if targetserver == nil then
						
						else
							targetname = targetname..'-'..targetserver 
						end
						local playernumber = PvPGrid:getPlayernumber(targetname)
						if playernumber ~= 0 then
							local text = 'x'.. 1+val2/100
							PvPGrid.mainframe['greenorb'].fontname:SetText(text)
							PvPGrid:setflag('greenorb', playernumber)
							
							showorb_green = true
						end
					end
				end
				
			end
		end
		if showflag_alliance == false then
			PvPGrid:HideFlag('allianceflag')
		end
		if showflag_horde == false then
			PvPGrid:HideFlag('hordeflag')
		end
		if showflag_nether == false then
			PvPGrid:HideFlag('netherflag')
		end
		
		if showorb_blue == false then
			PvPGrid:HideFlag('blueorb')
		end
		if showorb_purple == false then
			PvPGrid:HideFlag('purpleorb')
		end
		if showorb_orange == false then
			PvPGrid:HideFlag('orangeorb')
		end
		if showorb_green == false then
			PvPGrid:HideFlag('greenorb')
		end
	end)
	
	
	PvPGrid.mainframe.fontname = PvPGrid.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	PvPGrid.mainframe.fontname:SetPoint("TOPLEFT", 0, 0)
	PvPGrid.mainframe.fontname:SetText('PvPGrid')
	PvPGrid.mainframe.fontname:SetTextColor(1, 1, 1, 0.6)
	PvPGrid.mainframe.fontname:SetFont("Fonts\\FRIZQT__.ttf" , 10, "OUTLINE")
end

function PvPGrid:getPlayernumber(playername)
	for i = 1 , 15 , 1 do
		if PvPGrid.playergrid[i] then
			if PvPGrid.playergrid[i].name == playername then
				return i
			end
		end
	end
	return 0
end

function PvPGrid:create_playerframes()
	local height = self.db.profile.frameheight
	local width = self.db.profile.framewidth
	local fontsize = self.db.profile.fontsize 
	for i=1, 15, 1 do
		local framename = 'enemyplayer'..i
		self.mainframe[framename] = CreateFrame("Button", framename, self.mainframe, "SecureActionButtonTemplate")
		self.mainframe[framename]:SetPoint("TOPLEFT", 0, -10-(i-1)*height)
		self.mainframe[framename]:SetSize(width , height)
		--self.mainframe[framename]:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8"})
		--self.mainframe[framename]:SetBackdropColor(0.1*(i-1), 0, 0, 0.5)
		self.mainframe[framename]:RegisterForClicks("AnyUp")
		self.mainframe[framename]:SetAttribute("type1", "macro")
		self.mainframe[framename]:SetAttribute("macrotext1", "")
		--self.mainframe[framename]:SetMinMaxValues(0, 1)
		
		self.mainframe[framename].health = CreateFrame('StatusBar', nil, self.mainframe[framename])
		self.mainframe[framename].health:SetPoint('CENTER', 0, 0)
		self.mainframe[framename].health:SetSize(width , height)
		self.mainframe[framename].health:SetStatusBarTexture(media:Fetch("statusbar", self.db.profile.statusbarframe))
		self.mainframe[framename].health:SetBackdrop({
			bgFile = "Interface/Buttons/GreyscaleRamp64",
		});
		self.mainframe[framename].health:SetBackdropBorderColor(1,1,1,1);
		self.mainframe[framename].health:SetBackdropColor(0, 0, 0, 0.15)
		self.mainframe[framename].health:SetMinMaxValues(0, 1)
		self.mainframe[framename].health:SetValue(1)
		self.mainframe[framename].health:SetStatusBarColor(1,1,1,1);
		self.mainframe[framename].health:SetFrameStrata('LOW')
	
		self.mainframe[framename].fontpercent = self.mainframe[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
		self.mainframe[framename].fontpercent:SetPoint("LEFT", 1, 0)
		self.mainframe[framename].fontpercent:SetText('100')
		self.mainframe[framename].fontpercent:SetTextColor(1, 1, 1)
		self.mainframe[framename].fontpercent:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
		
		self.mainframe[framename].fontname = self.mainframe[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
		self.mainframe[framename].fontname:SetPoint("CENTER", 0, 0)
		self.mainframe[framename].fontname:SetText(i)
		self.mainframe[framename].fontname:SetTextColor(1, 1, 1)
		self.mainframe[framename].fontname:SetFont(media:Fetch("font", self.db.profile.mainfont) , fontsize, "OUTLINE")
		self.mainframe[framename].roleicon = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].roleicon:SetPoint("TOPLEFT", -height*2-2, 0)
		self.mainframe[framename].roleicon:SetSize(height , height)
		self.mainframe[framename].roleicon:SetTexture([[Interface\LFGFRAME\UI-LFG-ICON-ROLES]])
		self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.5, 0.75)
		self.mainframe[framename].specicon = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].specicon:SetPoint("TOPLEFT", -height-1, 0)
		self.mainframe[framename].specicon:SetSize(height , height)
		self.mainframe[framename].specicon:SetTexture([[Interface\ICONS\Trade_Engineering]])
		self.mainframe[framename]:Hide()
	end
end

function PvPGrid:updategrid()
	if not InCombatLockdown() then
		for i=1, 15, 1 do
			local framename = 'enemyplayer'..i
			self.mainframe[framename]:Hide()
			if not self.playergrid[i] then
				
			else
				self.mainframe[framename]:Show()
				self.mainframe[framename].fontname:SetText(self.playergrid[i].name)
				for j = 1, #PvPGrid.Classinfos[self.playergrid[i].class] do
					if self.playergrid[i].spec == PvPGrid.Classinfos[self.playergrid[i].class][j].specname then
						--print(self.playergrid[i].name..' is '..self.playergrid[i].spec)
						self.mainframe[framename].specicon:SetTexture(PvPGrid.Classinfos[self.playergrid[i].class][j].specicon)
						if PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "DAMAGER" then
							self.mainframe[framename].roleicon:SetTexCoord(0.25, 0.5, 0.25, 0.5)
						elseif PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "HEALER" then
							self.mainframe[framename].roleicon:SetTexCoord(0.25, 0.5, 0, 0.25)
						elseif PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "TANK" then
							self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.25, 0.5)
						else
							self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.5, 0.75)
						end
					end
				end
				local alphastatusbar =  0.3
				if testmode then
					alphastatusbar = 1
				end
				local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
				self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, alphastatusbar)
			
				
				self.mainframe[framename]:SetAttribute('macrotext1',
					'/cleartarget\n'..
					'/targetexact '..self.playergrid[i].name
				);
			end
		end
		for k = 1 , 15, 1 do
			local targetname, targetserver = UnitFullName('nameplate'..k)
			if targetserver == nil then
	
			else
				targetname = targetname..'-'..targetserver 
			end
			if targetname ~= nil then
				for i=1, 15, 1 do
					local framename = 'enemyplayer'..i
					if self.playergrid[i].name == targetname then
						local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
						self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
					end
				end
			end
		end
	end
end

function PvPGrid:default_players()
	self.playergrid = {}
	for i=2, 10, 1 do
		self.playergrid[i] = {}
	end
	self.playergrid[1] = {
		name = 'Rivah',
		class = 'MAGE',
		spec = 'Arkan',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[2] = {
		name = 'Armicron',
		class = 'DRUID',
		spec = 'Wildheit',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[3] = {
		name = 'Wyrlinia',
		class = 'DRUID',
		spec = 'Wächter',
		specrole = 'TANK',
		maxhealth = 1,
	}
	self.playergrid[4] = {
		name = 'Deex',
		class = 'MAGE',
		spec = 'Feuer',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[5] = {
		name = '纯洁的小猴-Chinese',
		class = 'WARRIOR',
		spec = 'Furor',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[6] = {
		name = 'Летнийдождь-Russian',
		class = 'WARLOCK',
		spec = 'Zerstörung',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[7] = {
		name = 'Unrealrules',
		class = 'PRIEST',
		spec = 'Heilig',
		specrole = 'HEALER',
		maxhealth = 1,
	}
	self.playergrid[8] = {
		name = '血腥馬克-Taiwanese',
		class = 'HUNTER',
		spec = 'Treffsicherheit',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[9] = {
		name = 'Groni',
		class = 'PALADIN',
		spec = 'Vergeltung',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
	self.playergrid[10] = {
		name = '사진작가-Korean',
		class = 'ROGUE',
		spec = 'Meucheln',
		specrole = 'DAMAGER',
		maxhealth = 1,
	}
end





function PvPGrid:update_playerinfo()
	PvPGrid:update_player()
	local playernumbers = GetNumBattlefieldScores()
	PvPGrid.playergrid = {}
	local j = 1
	for i = 1, playernumbers do
		local name,_,_,_,_,faction,_,_,class,_ ,_,_,_,_,_,spec = GetBattlefieldScore(i)
	
		if faction ~= PvPGrid.player.faction then
			--print(UnitGUID(name))
			PvPGrid.playergrid[j] = {}
			local specrole = ''
			for j = 1, #PvPGrid.Classinfos[class] do
				if spec == PvPGrid.Classinfos[class][j].specname then
					specrole = PvPGrid.Classinfos[class][j].specrole
				end
			end
			PvPGrid.playergrid[j] = {
				name = name,
				class = class,
				specrole = specrole,
				spec = spec,
				maxhealth = 1,
				guid = '',
			}
			j = j +1
		end
		
		--print(name..': '..class..' '..spec..' '..faction)
	end
end

function PvPGrid:showgrid()
	if testmode then
		self:default_players()
	else
		self:update_playerinfo()
	end
	self:sort_players()
	self:updategrid()
	if testmode then
		self.mainframe['enemyplayer5'].fontpercent:SetText(string.format("%.0f", 11/33)..'%')
		self.mainframe['enemyplayer5'].health:SetValue(11/33)
		local classColor = NORMAL_FONT_COLOR;	
									
		--self.mainframe['enemyplayer5'].health:SetBackdropColor(0,0,0, 0.15)
		self.mainframe['enemyplayer5'].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)							
	end
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end
function PvPGrid:sort_players(...)
	--local isfirst = ... or 0
	
	local playerdata = deepcopy(self.playergrid)
	allsorted = true
	for i = 1, 15, 2 do
		if playerdata[i+1] then
			local islower = self:sort(playerdata[i], playerdata[i+1])
			if islower == true then
				self.playergrid[i] = deepcopy(playerdata[i+1])
				self.playergrid[i+1] = deepcopy(playerdata[i])
				allsorted = false
			end
		end
	end
	playerdata = deepcopy(self.playergrid)
	for i = 2, 15, 2 do
		if playerdata[i+1] then
			local islower = self:sort(playerdata[i], playerdata[i+1])
			if islower == true then
				self.playergrid[i] = deepcopy(playerdata[i+1])
				self.playergrid[i+1] = deepcopy(playerdata[i])
				allsorted = false
			end
		end
	end
	if allsorted == false then
		PvPGrid:sort_players()
	end
end

function PvPGrid:sort(a, b)
	if self:specrolevalue(a.specrole) == self:specrolevalue(b.specrole) then
		if a.name > b.name then
			return true
		end
	elseif self:specrolevalue(a.specrole) > self:specrolevalue(b.specrole) then
		return true
	end
	return false
end

function PvPGrid:specrolevalue(role)
	if role == 'DAMAGER' then
		return 3
	elseif role == 'HEALER' then
		return 1
	elseif role == 'TANK' then
		return 2
	else
		print('Specrole Error '..role)
	end
end

function PvPGrid:PvP_Zone_check()
	local _, area = IsInInstance()
	if area == "pvp" then
		PvPGrid:onBG()
		PvPGrid.mainframe:Show()
	else
		if not testmode then
			PvPGrid.mainframe:Hide()
		end
	end
end

function PvPGrid:onBG()
	PvPGrid:showgrid()
end



function PvPGrid:target_check(...)
	local unit = (...)
	local targetunit = unit..'target'
	local targetguid = UnitGUID(targetunit)
	if targetguid ~= nil then
		local targetname, targetserver = UnitFullName(targetunit)
		if targetserver == nil then
		
		else
			targetname = targetname..'-'..targetserver 
		end
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",targetguid);
		if type == 'Player' then
			--print('target is '..targetname)
			if PvPGrid.playerinfos[targetname] == nil then --insert
				PvPGrid.playerinfos[targetname] = {}
				PvPGrid.playerinfos[targetname].guid = targetguid
				PvPGrid:update_health(targetunit)
			else --update
				PvPGrid:update_health(targetunit)
			end
		end
	end
end

function PvPGrid:update_health(unit, ...)
	local targetguid = UnitGUID(unit)
	if targetguid ~= nil then
		local targetname, targetserver = UnitFullName(unit)
		if targetserver == nil then
		
		else
			targetname = targetname..'-'..targetserver 
		end
		local health = UnitHealth(unit)
		local maxhealth = UnitHealthMax(unit)
		if PvPGrid.playerinfos[targetname] then
			PvPGrid.playerinfos[targetname].maxhealth = maxhealth
			PvPGrid.playerinfos[targetname].curhealth = health
			for i=1, 15, 1 do
				local framename = 'enemyplayer'..i
				if self.playergrid[i] then
					if  self.playergrid[i].name == targetname then
						self.mainframe[framename].health:SetValue(health/maxhealth)
						self.mainframe[framename].fontpercent:SetText(string.format("%.0f", health/maxhealth*100)..'%')
						local healthbarcolor = ... or 'nothing'
						if healthbarcolor == 'nothing' then
						
						elseif healthbarcolor == 'show' then
							for j = 1, #PvPGrid.Classinfos[self.playergrid[i].class] do
								if self.playergrid[i].spec == PvPGrid.Classinfos[self.playergrid[i].class][j].specname then
									local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
									self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
									--self:status(self.playergrid[i].name, true)
								end
							end
						elseif healthbarcolor == 'slice' then
							for j = 1, #PvPGrid.Classinfos[self.playergrid[i].class] do
								if self.playergrid[i].spec == PvPGrid.Classinfos[self.playergrid[i].class][j].specname then
									local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
									local alphabackground, alphastatusbar = 0.1, 0.3
									self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, alphastatusbar)
									--self:status(self.playergrid[i].name, false)
								end
							end
						else
							print('error barcolorinfo')
						end
						--print('healthupdate '..targetname)
					end
				end	
			end
		end
	end
end

function PvPGrid:status(name, status)
	if not PvPGrid.statusactive then
		PvPGrid.statusactive = {}
	end
	local players = PvPGrid.statusactive
	local allrdyin = false
	if players then
		for i = 1, #players do
			if players[i] == name then
				if status == false then
					table.remove(PvPGrid.statusactive, i)
					print('remove '..name)
				elseif status == true then	
					allrdyin = true
					print('alrdyin '..name)
				end
			end
		end
	end
	if allrdyin == false and status == true then
		table.insert(PvPGrid.statusactive, name)
		print('insert '..name)
	end
end

function PvPGrid:show_bar(unit)
	PvPGrid:update_health(unit, 'show')
end

function PvPGrid:slice_bar(unit)
	PvPGrid:update_health(unit, 'slice')
end


function PvPGrid_OnEvent(self, event, ...)
	if event == 'ZONE_CHANGED_NEW_AREA' then
		PvPGrid:PvP_Zone_check()
	elseif event == "UPDATE_BATTLEFIELD_SCORE" then
		PvPGrid:onBG()
	elseif event == "UNIT_TARGET" then
		PvPGrid:target_check(...)
	elseif event == "UNIT_HEALTH_FREQUENT" then
		PvPGrid:update_health(...)	
	elseif event == "NAME_PLATE_UNIT_ADDED" then
		PvPGrid:show_bar(...)
	elseif event == "NAME_PLATE_UNIT_REMOVED" then
		PvPGrid:slice_bar(...)
	end
end

